--
--          This file is part of the New World OS and Objectify projects
--                     Copyright (C) 2008, 2009  QRW Software
--               J. Scott Edwards - j.scott.edwards.nwos@gmail.com 
--
--   This program is free software: you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation, either version 3 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program, in the file LICENSE.  If not, see 
--   <http://www.gnu.org/licenses/>.
--
--   For the latest information, source code (SVN), releases, and bug tracking
--   go to:
--      http://savannah.nongnu.org/projects/objectify
--
--   For releases from Alpha_30 and up, bug and feature request tracking go to:
--      http://sourceforge.net/projects/objectify
--
--   For older bug tracking, releases and source code (CVS) prior to the
--   Alpha_30 release go to:
--      http://sourceforge.net/projects/nwos
--
--   Other related websites:
--      http://www.qrwsoftware.com
--      http://www.worldwide-database.org
--
--   You can also contact me via paper mail at:
--
--      QRW Software
--      P.O. Box 27511
--      Salt Lake City, UT 84127-0511, USA.
--
--   $Author: jsedwards $
--   $Date: 2009-10-06 08:06:23 -0600 (Tue, 06 Oct 2009) $
--   $Revision: 4384 $
--
--   NOTE: Subversion does not support the Log keyword so I have removed the
--   logs that were here when I was using CVS.  Use the "svn log" command to
--   see the revision history of this file.
--   (See http://subversion.tigris.org/faq.html#log-in-source)
--


class FILE_PATH

inherit OBJECTIFY_OBJECT

creation read_from_disk

feature

   read_from_disk(id: REFERENCE) is
      do
         !!reference.copy(id)
         storage := wrapper_read_file_path(reference.to_external)

--             std_output.put_string("Ref list count: ");
--             std_output.put_integer(references.count);
--             std_output.put_new_line;
      end

   path: STRING is
      do
         if save_path = Void then
            from
               !!save_path.make(wrapper_file_path_count(storage))
            until
               save_path.count = save_path.capacity
            loop
               save_path.extend(wrapper_file_path_item(storage, save_path.count))
            end
         end

         Result := save_path
      end

feature {NONE}

   save_path: STRING

   wrapper_read_file_path(ref: POINTER): POINTER is
      external "C"
      end

   wrapper_file_path_count(obj: POINTER): INTEGER is
      external "C"
      end

   wrapper_file_path_item(obj: POINTER; index: INTEGER): CHARACTER is
      external "C"
      end

end

