--
--          This file is part of the New World OS and Objectify projects
--                        Copyright (C) 2009  QRW Software
--               J. Scott Edwards - j.scott.edwards.nwos@gmail.com 
--
--   This program is free software: you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation, either version 3 of the License, or
--   (at your option) any later version.
--
--   This program is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with this program, in the file LICENSE.  If not, see 
--   <http://www.gnu.org/licenses/>.
--
--   For the latest information, source code (SVN), releases, and bug tracking
--   go to:
--      http://savannah.nongnu.org/projects/objectify
--
--   For releases from Alpha_30 and up, bug and feature request tracking go to:
--      http://sourceforge.net/projects/objectify
--
--   For older bug tracking, releases and source code (CVS) prior to the
--   Alpha_30 release go to:
--      http://sourceforge.net/projects/nwos
--
--   Other related websites:
--      http://www.qrwsoftware.com
--      http://www.worldwide-database.org
--
--   You can also contact me via paper mail at:
--
--      QRW Software
--      P.O. Box 27511
--      Salt Lake City, UT 84127-0511, USA.
--
--   $Author: jsedwards $
--   $Date: 2009-10-06 08:06:23 -0600 (Tue, 06 Oct 2009) $
--   $Revision: 4384 $
--
--   NOTE: Subversion does not support the Log keyword so I have removed the
--   logs that were here when I was using CVS.  Use the "svn log" command to
--   see the revision history of this file.
--   (See http://subversion.tigris.org/faq.html#log-in-source)
--
--
--   This program changes the format of the ChangeLog file to something
--   more friendly for pasting into the SourceForge change log.
--


class FIX_CHANGE_LOG

creation make

feature

   make is
      local
         input_line, output_line: STRING
      do
         !!input_line.make(80)
         !!output_line.make(1024)

         from
            std_input.read_line_in(input_line)
         until
            std_input.end_of_input
         loop
             if input_line.is_empty then              -- flush
                if not output_line.is_empty then
                   std_output.put_string(output_line)
                   std_output.put_new_line
                   output_line.clear
                end

                std_output.put_new_line
                output_line.clear
             elseif input_line.has_prefix("%T") then  -- fix it up
               input_line.remove_first(1)

               if input_line.has_prefix("*") or else input_line.has_prefix("(") then
                  std_output.put_string(output_line)
                  std_output.put_new_line

                  output_line.copy("    ")
                  output_line.append(input_line)
               else
                  output_line.append(" ")
                  output_line.append(input_line)
               end
            else                                       -- date line
               if not output_line.is_empty then
                  std_output.put_string(output_line)
                  std_output.put_new_line
                  output_line.clear
               end

               std_output.put_string(input_line)
               std_output.put_new_line
            end

            std_input.read_line_in(input_line)
         end

         if not output_line.is_empty then
            std_output.put_string(output_line)
            std_output.put_new_line
         end
      end

end

